	template < class T >
	struct Array
	{
		Array()
		{
			size= 0;
			allocSize= 0;
			hunkSize= 256;
			data= NULL;
		}

		~Array()
		{
			delete []data;
		}
		

		T& operator[]( const int selector )
		{
			assert( selector < size );
			return data[ selector ];
		}
		const T& operator[]( const int selector ) const
		{
			assert( selector < size );
			return data[ selector ];
		}

		T& Last() { return data[ size ]; }
		// unpredicable results if the list is empty
		T& First() { return data[ 0 ]; }
	

		Array<T>& operator=( const Array< T >& other )
		{
			Resize( other.size );

			memcpy( data, other.data, other.size*sizeof( T ) );

			return *this;
		}

		// inserts the given element at the end of the array
		void Insert( const T& newElement )
		{
			if( size == allocSize )
			{
				// size == allocSize
				AddHunk();			
			}

			data[ size ]= newElement;
			size++;
		}

		// inserts an element at the end of the array and returns a reference to it
		T& Insert()
		{
			if( size == allocSize )
				// size == allocSize
				AddHunk();			

			size++;

			return data[ size - 1 ];
		}

		// not done yet.. :(
		void Reserve( const int newSize )
		{
			assert( false );
			if( newSize > allocSize )
			{
				
			}
		}

		void Resize( const int newSize )
		{
			if( newSize != size )
			{
				if( newSize < allocSize )
				{
					size= newSize;
				}
				else
				{
					int oldAllocSize= allocSize;

					allocSize= newSize;

					T* t= new T[ allocSize ];

					memcpy( t, data, sizeof( T )*size );

					delete []data;

					data= t;
					size= newSize;
				}
			}

			CheckValue( (qbyte)data );
		}

		void AddHunk()
		{
			int oldAllocSize= allocSize;

			allocSize+= hunkSize;

			T* t= new T[ allocSize ];

			memcpy( t, data, sizeof( T )*size );

			delete []data;

			data= t;
		}

		// removes the item at the specified location
		// *expensive*
		void Remove( const int location )
		{
			assert( location < size );
			memmove( &data[ location ], &data[ location + 1 ], sizeof( T )*(size-location) );
			size--;
		}

		// calls the non-array destructor on all the elements of the array
		void DeleteAll()
		{
			for( int i= 0; i< size; i++ )
				delete data[ i ];
			RemoveAll();
		}

		// empties the array
		void RemoveAll()
		{
			size= 0;
		}

		// returns the index of the element if it is in the array
		// -1 if it is not there
		int Find( T t )
		{
			for( int i= 0; i< size; i++ )
				if( t == data[ i ] )
					return i;

			return -1;
		}

		int size;
		int allocSize;
		T* data;

		int hunkSize;
	};
